include_theme('lightning-rabbit')
include_theme('body-background-image')

@headline_logo_image = "usa1.png"
include_theme("headline-logo")

def Kernel.log(msg)
  open('log', 'w') { |f| f.puts msg.to_s }
end

match(TitleSlide) do |elements|
  elements.prop_set('size', screen_size(7) * Pango::SCALE)
end

match('**', Text) do |elements|
  elements.each do |text|
    case text.text
    when /Feature #/, /Show documents when completion/
      text.prop_set('size', screen_size(4) * Pango::SCALE)
    when /terminal techniques/
      text.prop_set('size', screen_size(5) * Pango::SCALE)
    when /may_req_ambiguous_char_width/
      text.prop_set('size', screen_size(4.5) * Pango::SCALE)
    when /docs\.microsoft\.com/
      text.prop_set('size', screen_size(2.2) * Pango::SCALE)
    end
  end
end

match('**', BlockQuote) do |elements|
  elements.prop_set('size', screen_size(5.0) * Pango::SCALE)
end

match('*', HeadLine) do |elements|
  elements.each do |headline|
    if headline.text.match?(/Design/)
      headline.prop_set('size', screen_size(4.5) * Pango::SCALE)
    else
      headline.prop_set('size', screen_size(5.2) * Pango::SCALE)
    end
  end
end

match('**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(5.0) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
end

match('**', ItemListItem, '**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(4.0) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
end

match('**', ItemListItem, '**', ItemListItem, '**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(3.3) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
end

match('**', ItemListItem, '**', ItemListItem, '**', ItemListItem, '**', ItemListItem) do |elements|
  elements.prop_set('size', screen_size(3) * Pango::SCALE)
  elements.padding_top = 0
  elements.padding_bottom = 0
  elements.margin_top = 0
  elements.margin_bottom = 0
  elements.margin_left = screen_size(4)
end

match('**', ItemListItem) do |elements|
  elements.select{ |e| e.text.match?(/Matsuda-san is/) }.each do |e|
    e.prop_set('size', screen_size(3) * Pango::SCALE)
  end
end

match('**', Image) do |images|
  images.each do |image|
    if image.caption&.match?(/strange.*arrows/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/Both.*culture/) or image.caption&.match?(/Elasticsearch/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/injured TFCC/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.0) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/I got right anterior cruciate ligament injury/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.0) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/Sometimes I use computer on the floor/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.0) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/New headache/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/Stiffness of/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    elsif image.caption&.match?(/prosthetic finger/)
      image.add_pre_draw_proc(:save_url) do |canvas, x, y, w, h, simulation|
        unless @image_caption_font_size_backup
          @image_caption_font_size_backup = @image_caption_font_size
          @image_caption_font_size = screen_size(4.5) * Pango::SCALE
        end
        [x, y, w, h]
      end
    else
      image.add_pre_draw_proc(:restore_url) do |canvas, x, y, w, h, simulation|
        if @image_caption_font_size_backup
          @image_caption_font_size = @image_caption_font_size_backup
          @image_caption_font_size_backup = nil
        end
        [x, y, w, h]
      end
    end
  end
end

match('*') do |elements|
  elements.each do |slide|
    if slide.title.match?(/fullimage/)
      slide.each do |e|
        if e.instance_of?(Body)
          image = e.first
          image.add_pre_draw_proc(:bbbb) do |canvas, x, y, w, h, simulation|
            image.resize(canvas.width, canvas.height)
            [0.0, 0.0, w, h]
          end
        end
      end
    elsif slide.title.match?(/notitle/)
      slide.each do |e|
        if e.instance_of?(HeadLine)
          e.prop_set('size', screen_size(0) * Pango::SCALE)
        end
      end
    elsif slide.title.match?(/Win32 API/)
      slide.each do |e|
        e.each do |inside|
          if inside.instance_of?(ItemList)
            inside.each do |item|
              case item.text
              when /GetStdHandle/, /SetConsoleCursorPosition/, /GetConsoleScreenBufferInfo/, /blah blah blah/
                item.prop_set('size', screen_size(4) * Pango::SCALE)
              end
            end
          end
        end
      end
    elsif slide.title.match?(/Unicode support/)
      slide.each do |e|
        e.each do |inside|
          if inside.instance_of?(ItemList)
            inside.each do |item|
              case item.text
              when /combination plural/, /depending on the situation/, /blah blah blah/
                item.prop_set('size', screen_size(3.5) * Pango::SCALE)
              end
            end
          end
        end
      end
    elsif slide.title.match?(/Line editing implementation/)
      if (slide.any?{ |e| e.text.match?(/operation method list\(smaller\)/) })
        slide.each do |e|
          e.each do |inside|
            if inside.instance_of?(ItemList)
              inside.each do |item|
                item.prop_set('size', screen_size(2) * Pango::SCALE)
                item.find_all { |i| i.text.match?(/operation method list/) }.each { |i| i.prop_set('size', screen_size(4) * Pango::SCALE) }
              end
            end
          end
        end
      elsif (slide.any?{ |e| e.text.match?(/operation method list\(smallest\)/) })
        slide.each do |e|
          e.each do |inside|
            if inside.instance_of?(ItemList)
              inside.each do |item|
                item.prop_set('size', screen_size(1) * Pango::SCALE)
                item.find_all { |i| i.text.match?(/operation method list/) }.each { |i| i.prop_set('size', screen_size(4) * Pango::SCALE) }
              end
            end
          end
        end
      elsif (slide.any?{ |e| e.text.match?(/operation method list\(smallest\)/) })
        slide.each do |e|
          e.each do |inside|
            if inside.instance_of?(ItemList)
              inside.each do |item|
                item.prop_set('size', screen_size(1) * Pango::SCALE)
                item.find_all { |i| i.text.match?(/operation method list/) }.each { |i| i.prop_set('size', screen_size(4) * Pango::SCALE) }
              end
            end
          end
        end
      elsif (slide.any?{ |e| e.text.match?(/operation and motion/) })
        slide.each do |e|
          e.each do |inside|
            if inside.instance_of?(ItemList)
              inside.each do |item|
                item.prop_set('size', screen_size(2) * Pango::SCALE)
              end
            end
          end
        end
      end
    end
  end
end
